#if defined _ttt_stocks_included
  #endinput
#endif
#define _ttt_stocks_included

#if !defined _ttt_included
	#include <ttt>
#endif

stock const death_messages[][] =
{
	"TTT_KILL_SUICIDE",
	"TTT_KILL_GENERIC",
	"TTT_KILL_SLASH",
	"TTT_KILL_BURN",
	"TTT_KILL_FREEZE",
	"TTT_KILL_FALL",
	"TTT_KILL_BLAST",
	"TTT_KILL_SHOCK",
	"TTT_KILL_DROWN",
	"TTT_KILL_NERVEGAS",
	"TTT_KILL_POISON",
	"TTT_KILL_RADIATION",
	"TTT_KILL_ACID"
};

stock const special_names[][] =
{
	"TTT_NONE",
	"TTT_TRAITOR",
	"TTT_DETECTIVE",
	"TTT_INNOCENT",
	"TTT_DEAD",
	"TTT_SPECIAL"
};

stock is_dead_body(classname[])
{
	if(equali(classname, TTT_DEADBODY))
		return 1;
	return 0;
}

stock ttt_return_check(id)
{
	if(!is_user_connected(id) || ttt_get_game_state() == OFF || ttt_get_game_state() == ENDED)
		return 1;

	return 0;
}

stock auto_exec_config(const szName[], bool:bAutoCreate=true)
{
	new szFileName[32];
	new iLen = copy(szFileName, charsmax(szFileName), szName);
	if(iLen <= 4 || !equal(szFileName[iLen-4], ".cfg"))
		add(szFileName, charsmax(szFileName), ".cfg");

	new szConfigPath[96];
	get_localinfo("amxx_configsdir", szConfigPath, charsmax(szConfigPath));
	format(szConfigPath, charsmax(szConfigPath), "%s/%s", szConfigPath, szFileName);

	if(file_exists(szConfigPath))
	{
		server_cmd("exec %s", szConfigPath);
		server_exec();
		return 1;
	}
	else if(bAutoCreate)
	{
		new fp = fopen(szConfigPath, "wt");
		if(!fp)
			return -1;
		new szPluginFileName[96], szPluginName[64], szAuthor[32], szVersion[32], szStatus[2];
		new iPlugin = get_plugin(-1, 
					szPluginFileName, charsmax(szPluginFileName), 
					szPluginName, charsmax(szPluginName), 
					szVersion, charsmax(szVersion), 
					szAuthor, charsmax(szAuthor), 
					szStatus, charsmax(szStatus));

		fprintf(fp, "; ^"%s^" onfiguration file^n", szPluginName);
		fprintf(fp, "; Author : ^"%s^"^n", szAuthor);
		fprintf(fp, "; Version : ^"%s^"^n", szVersion);
		fprintf(fp, "; File : ^"%s^"^n", szPluginFileName);

		new iMax;
		iMax = get_plugins_cvarsnum();
		new iTempId, iPcvar, szCvarName[256], szCvarValue[128], i;
		for(i = 0; i<iMax; i++)
		{
			get_plugins_cvar(i, szCvarName, charsmax(szCvarName), _, iTempId, iPcvar);
			if(iTempId == iPlugin)
			{
				get_pcvar_string(iPcvar, szCvarValue, charsmax(szCvarValue));
				fprintf(fp, "%s ^"%s^"^n", szCvarName, szCvarValue);
			}
		}

		fclose(fp);
	}
	return 0;
}

stock create_icon_origin(id, Float:origin[3], sprite, scale) // By sontung0
{
	if(!is_in_viewcone(id, origin))
		return;

	new Float:fMyOrigin[3];
	entity_get_vector(id, EV_VEC_origin, fMyOrigin);

	new Float:fMiddle[3], Float:fHitPoint[3];
	xs_vec_sub(origin, fMyOrigin, fMiddle);
	trace_line(-1, fMyOrigin, origin, fHitPoint);

	new Float:fWallOffset[3], Float:fDistanceToWall;
	fDistanceToWall = vector_distance(fMyOrigin, fHitPoint) - 10.0;
	normalize(fMiddle, fWallOffset, fDistanceToWall);

	new Float:fSpriteOffset[3];
	xs_vec_add(fWallOffset, fMyOrigin, fSpriteOffset);

	te_sprite(id, fSpriteOffset, sprite, scale);
}

stock te_sprite(id, Float:origin[3], sprite, scale) // By sontung0
{	
	message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, id);
	write_byte(TE_SPRITE);
	write_coord(floatround(origin[0]));
	write_coord(floatround(origin[1]));
	write_coord(floatround(origin[2]));
	write_short(sprite);
	write_byte(scale);
	write_byte(255);
	message_end();
}

stock normalize(Float:fIn[3], Float:fOut[3], Float:fMul) // By sontung0
{
	new Float:fLen = xs_vec_len(fIn);
	xs_vec_copy(fIn, fOut);
	
	fOut[0] /= fLen, fOut[1] /= fLen, fOut[2] /= fLen;
	fOut[0] *= fMul, fOut[1] *= fMul, fOut[2] *= fMul;
}

stock ttt_is_jailmap()
{
	static mapname[32];
	get_mapname(mapname, charsmax(mapname));

	if(equali(mapname, "jail_", 5) || equali(mapname, "jb_", 3) || equali(mapname, "jailbreak_", 10))
		return 1;

	return 0;
}

stock ttt_make_deathmsg(killer, victim, headshot, const weapon[])
{
	if(!is_user_connected(victim) || !is_user_connected(killer))
		return;

	new num, specstate, i, msg = get_user_msgid("DeathMsg");
	static players[32];
	get_players(players, num);
	for(--num; num >= 0; num--)
	{
		i = players[num];
		specstate = ttt_get_special_state(i);
		if(specstate == TRAITOR || specstate == NONE || specstate == DEAD || i == victim)
		{
			message_begin(MSG_ONE_UNRELIABLE, msg, _, i);
			write_byte(killer);
			write_byte(victim);
			write_byte(headshot);
			write_string(weapon);
			message_end();
		}
	}	
}

stock find_that_ent(id, Float:mindist, classname[])
{
	static Float:vecEnd[3], Float:vecAim[3];
	pev(id, pev_origin, vecEnd);
	pev(id, pev_view_ofs, vecAim);

	vecAim[0] += vecEnd[0];
	vecAim[1] += vecEnd[1];
	vecAim[2] += vecEnd[2];

	static iCorpses[33], iCorpsesFound;
	iCorpsesFound = find_sphere_class(0, classname, mindist, iCorpses, charsmax(iCorpses), vecAim);

	if(iCorpsesFound <= 0)
		return 0;

	velocity_by_aim(id, floatround(mindist), vecEnd);
	vecAim[0] += vecEnd[0];
	vecAim[1] += vecEnd[1];
	vecAim[2] += vecEnd[2];

	static ptr;
	engfunc(EngFunc_TraceLine, vecAim, vecEnd, DONT_IGNORE_MONSTERS, id, ptr);
	get_tr2(ptr, TR_vecEndPos, vecEnd);

	static i, ent;
	for(i = 0; i < iCorpsesFound; i++)
	{
		ent = iCorpses[i];
		engfunc(EngFunc_TraceModel, vecAim, vecEnd, HULL_POINT, ent, ptr);
		if(get_tr2(ptr, TR_pHit) == ent)
			return ent;
	}

	return 0;
}
