#include <amxmodx>
#include <ttt>

new const g_sWeaponNames[][] = 
{
	"suicide", "p228", "", "scout", "hegrenade", "xm1014", "c4", "mac10", "aug", "hegrenade", "elite", "fiveseven",
	"ump45", "sg550", "galil", "famas", "usp", "glock18", "awp", "mp5navy", "m249", "m3", "m4a1", "tmp", "g3sg1", "hegrenade",
	"deagle", "sg552", "ak47", "crowbar", "p90"
};

public plugin_init()
{
	register_plugin("[TTT] DeathMessages", TTT_VERSION, TTT_AUTHOR);
}

public plugin_natives()
{
	register_library("ttt");
	register_native("ttt_get_kill_message", "_get_kill_message");
}

public _get_kill_message(plugin, params)
{
	if(params != 5)
		return ttt_log_to_file(LOG_ERROR, "Wrong number of params (ttt_get_kill_message)");

	new id = get_param(1);
	if(!is_user_alive(id))
	{
		new killer = get_param(2);
		new len = get_param(4);
		new type = get_param(5);
		static message[128], weapmsg[32];

		if(ttt_get_ds_kill(id))
			formatex(weapmsg, charsmax(weapmsg), "%L", LANG_PLAYER, "TTT_ITEM_ID8");
		else if(ttt_is_usp_kill(id))
			formatex(weapmsg, charsmax(weapmsg), "%L", LANG_PLAYER, "TTT_ITEM_ID10");
		else if(ttt_is_knife_kill(id))
			formatex(weapmsg, charsmax(weapmsg), "%L", LANG_PLAYER, "TTT_ITEM_ID11");
		else
		{
			//killer = ttt_get_playerdata(id, KILLEDBY);
			new weap = ttt_get_playerdata(id, PD_KILLEDWEAP);
			if(weap >= 3000)
				formatex(weapmsg, charsmax(weapmsg), "%L", LANG_PLAYER, death_messages[weap-3000]);
			else formatex(weapmsg, charsmax(weapmsg), "%s", g_sWeaponNames[weap]);
		}

		if(type)
		{
			if(is_user_connected(killer))
			{
				static name[32];
				get_user_name(killer, name, charsmax(name));
				formatex(message, len, "[%L] %s with %s", LANG_PLAYER, special_names[ttt_get_special_alive(killer)], name, weapmsg);
			}
			else formatex(message, len, "%s", weapmsg);
		}
		else formatex(message, len, "%s", weapmsg);

		set_string(3, message, len);
		return 1;
	}

	return 0;
}