#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <engine>
#include <ttt>

#if defined TTT_HAMBOTS
#include <cs_ham_bots_api>
#endif

#define m_pPlayer					41
#define m_flNextPrimaryAttack		46
#define m_flNextSecondaryAttack		47
#define m_flTimeWeaponIdle			48

new const knife_viewmodel[] = "models/v_knife.mdl";
new const knife_playermodel[] = "models/p_knife.mdl";
new const knife_worldmodel[] = "models/ttt/w_throwingknife.mdl";
new const Float:g_szDroppedSize[][3] =
{
	{-20.0, -20.0, -5.0},
	{20.0, 20.0, 5.0}
};

new g_iHasKnife[33], g_iCurrentWeapon[33], g_iHasTemp[33], g_iKilledByKnife[33], g_iItem_Knife;
new cvar_dmgmult, cvar_pattack_rate, cvar_sattack_rate, cvar_pattack_recoil, cvar_sattack_recoil, cvar_price_knife, cvar_knife_glow, cvar_knife_velocity;

public plugin_precache()
{
	precache_model(knife_viewmodel);
	precache_model(knife_playermodel);
	precache_model(knife_worldmodel);
}

public plugin_init()
{
	register_plugin("[TTT] Item: Knife", TTT_VERSION, TTT_AUTHOR);

	register_event("CurWeapon", "Event_CurWeapon", "b", "1=1");

	cvar_dmgmult			= register_cvar("ttt_knife_multi",				"11.0");
	cvar_pattack_rate		= register_cvar("ttt_knife_primary_rate",		"0.6");
	cvar_sattack_rate		= register_cvar("ttt_knife_secondary_rate", 	"1.3");
	cvar_pattack_recoil		= register_cvar("ttt_knife_primary_recoil", 	"-3.6");
	cvar_sattack_recoil		= register_cvar("ttt_knife_secondary_recoil",	"-5.0");
	cvar_price_knife		= register_cvar("ttt_price_knife",				"3");
	cvar_knife_glow			= register_cvar("ttt_knife_glow",				"1");
	cvar_knife_velocity		= register_cvar("ttt_knife_velocity",			"1500");

	RegisterHam(Ham_Touch, "info_target", "Ham_Touch_pre", 0);
	RegisterHam(Ham_Killed, "player", "Ham_Killed_pre", 0);
	RegisterHam(Ham_TakeDamage, "player", "Ham_TakeDamage_pre", 0);
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_knife", "Ham_PrimaryAttack_post", 1);
	RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_knife", "Ham_SecondaryAttack_post", 1);

#if defined TTT_HAMBOTS
	RegisterHamBots(Ham_Killed, "Ham_Killed_pre", 0);
	RegisterHamBots(Ham_TakeDamage, "Ham_TakeDamage_pre", 0);
#endif

	new name[TTT_ITEMNAME];
	formatex(name, charsmax(name), "%L", LANG_PLAYER, "TTT_ITEM_ID11");
	g_iItem_Knife = ttt_buymenu_add(name, get_pcvar_num(cvar_price_knife), TRAITOR);

	register_clcmd("drop", "clcmd_drop");
	register_clcmd("weapon_knife", "clcmd_knife");
}

public plugin_natives()
{
	register_library("ttt");
	register_native("ttt_is_knife_kill", "_is_knife_kill");
	register_native("ttt_knife_holding", "_knife_holding");
}

public client_disconnect(id)
{
	g_iHasKnife[id] = false;
	g_iHasTemp[id] = false;
	g_iKilledByKnife[id] = false;
}

public ttt_gamemode(gamemode)
{
	if(gamemode == ENDED || gamemode == RESTARTING)
	{
		remove_entity_name(TTT_KNIFE_DROP);
		remove_entity_name(TTT_KNIFE_THROW);

		new num, id;
		static players[32];
		get_players(players, num);
		for(--num; num >= 0; num--)
		{
			id = players[num];
			g_iHasKnife[id] = false;
			g_iHasTemp[id] = false;
			g_iKilledByKnife[id] = false;
		}
	}
}

public ttt_item_selected(id, item, name[], price)
{
	if(g_iItem_Knife == item)
	{
		if(get_user_weapon(id) == CSW_KNIFE)
			strip_knife(id, 1, 0);
		else
		{
			g_iHasKnife[id] = true;
			g_iHasTemp[id] = false;
		}

		ColorChat(id, NORMAL, "%s %L", TTT_TAG, id, "TTT_ITEM2", name, id, "TTT_ITEM5");
		return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}

public clcmd_drop(id)
{
	if(g_iHasKnife[id] && g_iCurrentWeapon[id] == CSW_KNIFE)
	{
		create_knife(id, 64, TTT_KNIFE_DROP, 1);
		return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}

public clcmd_knife(id)
{
	if(g_iCurrentWeapon[id] == CSW_KNIFE)
	{
		if(g_iHasKnife[id])
			strip_knife(id, 0, 1);
		else if(g_iHasTemp[id])
			strip_knife(id, 1, 0);
	}
}

public create_knife(id, vel, classname[], type)
{
	if(!is_user_connected(id) || !g_iHasKnife[id])
		return PLUGIN_HANDLED;
	
	client_cmd(id, "weapon_knife");

	new Float:origin[3], Float: velocity[3], Float:v_angle[3], ent;
	entity_get_vector(id, EV_VEC_origin, origin);
	entity_get_vector(id, EV_VEC_v_angle, v_angle);

	ent = create_entity("info_target");
	entity_set_string(ent, EV_SZ_classname, classname);
	entity_set_model(ent, knife_worldmodel);
	if(!type)
		entity_set_size(ent, Float:{-2.0, -2.0, -2.0}, Float:{2.0, 2.0, 2.0});
	else entity_set_size(ent, g_szDroppedSize[0], g_szDroppedSize[1]);

	VelocityByAim(id, vel, velocity);
	if(type == 1)
	{
		v_angle[0] = 270.0;
		origin[0] += velocity[0];
		origin[1] += velocity[1];
	}
	else v_angle[0] += 270.0;

	entity_set_origin(ent, origin);
	entity_set_vector(ent, EV_VEC_angles, v_angle);

	entity_set_int(ent, EV_INT_effects, EF_MUZZLEFLASH);
	entity_set_int(ent, EV_INT_solid, SOLID_TRIGGER);
	entity_set_int(ent, EV_INT_movetype, MOVETYPE_TOSS);
	entity_set_int(ent, EV_INT_iuser1, id);
	entity_set_edict(ent, EV_ENT_owner, id);

	entity_set_vector(ent, EV_VEC_velocity, velocity);
	if(get_pcvar_num(cvar_knife_glow))
	{
		new Float:color[3];
		color[0] = random_float(1.0, 255.0), color[1] = random_float(1.0, 255.0), color[2] = random_float(1.0, 255.0);
		UTIL_SetRendering(ent, kRenderFxGlowShell, color, _, 100.0);
	}

	strip_knife(id, 0, 0);
	return PLUGIN_HANDLED;
}

public Event_CurWeapon(id)
{
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE;

	g_iCurrentWeapon[id] = read_data(2);
	if(!g_iHasKnife[id] || g_iCurrentWeapon[id] != CSW_KNIFE)
		return PLUGIN_CONTINUE;

	entity_set_string(id, EV_SZ_viewmodel, knife_viewmodel);
	entity_set_string(id, EV_SZ_weaponmodel, knife_playermodel);

	return PLUGIN_CONTINUE;
}

public Ham_TakeDamage_pre(victim, inflictor, attacker, Float:damage, damage_bits)
{	
	if(victim == attacker || !is_user_connected(attacker))
		return HAM_IGNORED;

	if(g_iHasKnife[attacker] && g_iCurrentWeapon[attacker] == CSW_KNIFE)
	{
		a_lot_of_blood(victim);
		SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmgmult));
	}

	return HAM_HANDLED;
}

public Ham_Killed_pre(victim, killer, shouldgib)
{
	if(victim == killer || !killer || !is_user_connected(killer))
		return HAM_IGNORED;
	
	if(g_iHasKnife[victim])
		create_knife(victim, 10, TTT_KNIFE_DROP, 1);
	if(g_iHasKnife[killer])
		g_iKilledByKnife[victim] = true;

	return HAM_HANDLED;
}

public Ham_PrimaryAttack_post(knife)
{	
	static id;
	id = get_pdata_cbase(knife, m_pPlayer, 4);
	if(is_user_connected(id) && g_iHasKnife[id])
	{
		attack_post(id, knife, get_pcvar_float(cvar_pattack_rate), get_pcvar_float(cvar_pattack_recoil));
		create_knife(id, get_pcvar_num(cvar_knife_velocity), TTT_KNIFE_THROW, 0);
	}

	return HAM_HANDLED;
}

public Ham_SecondaryAttack_post(knife)
{	
	static id;
	id = get_pdata_cbase(knife, m_pPlayer, 4);
	if(is_user_connected(id) && g_iHasKnife[id])
		attack_post(id, knife, get_pcvar_float(cvar_sattack_rate), get_pcvar_float(cvar_sattack_recoil));

	return HAM_HANDLED;
}

public Ham_Touch_pre(knife, id)
{
	static classname[32];
	entity_get_string(knife, EV_SZ_classname, classname, charsmax(classname));

	if(equal(classname, TTT_KNIFE_DROP))
	{
		if(is_user_alive(id) && !g_iHasKnife[id])
		{
			strip_knife(id, 1, 0);
			emit_sound(id, CHAN_WEAPON, "items/gunpickup2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
			remove_entity(knife);
		}
	}
	else if(equal(classname, TTT_KNIFE_THROW))
	{
		if(is_user_alive(id))
		{
			if(!g_iHasKnife[id])
			{
				if(entity_get_int(knife, EV_INT_movetype) == MOVETYPE_NONE)
				{
					strip_knife(id, 1, 0);
					emit_sound(id, CHAN_WEAPON, "items/gunpickup2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
					remove_entity(knife);
				}
				else
				{
					new owner = entity_get_edict(knife, EV_ENT_owner);
					if(owner == id || !owner)
						return HAM_IGNORED;

					remove_entity(knife);
					ExecuteHam(Ham_TakeDamage, id, owner, owner, 150.0, DMG_SLASH);
					emit_sound(id, CHAN_WEAPON, "weapons/knife_hit4.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);

					if(!is_user_alive(id))
					{
						g_iKilledByKnife[id] = true;
						g_iHasKnife[id] = true;
						create_knife(id, 10, TTT_KNIFE_DROP, 1);
					}
				}
			}
		}
		else
		{
			entity_set_int(knife, EV_INT_movetype, MOVETYPE_NONE);
			new dropped = drop_to_floor(knife);
			if(!dropped)
			{
				new num, Float:origin[3];
				entity_get_vector(knife, EV_VEC_origin, origin);
				dropped = make_vacant(knife, origin, num, 15.0);
				//log_amx("ID  %d,  Knife %d, ORIGIN %0.2f, %0.2f, %0.2f, NUM %d", id, knife, origin[0], origin[1], origin[2], num);
			}

			if(!dropped)
			{
				strip_knife(id, 1, 0);
				remove_entity(knife);
			}
			else
			{
				entity_set_size(knife, g_szDroppedSize[0], g_szDroppedSize[1]);
				drop_to_floor(knife);
				entity_set_edict(knife, EV_ENT_owner, 0);
				
				emit_sound(knife, CHAN_AUTO, "weapons/knife_hitwall1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
				static Float:angles[3];
				entity_get_vector(knife, EV_VEC_angles, angles);
				angles[0] = 270.0;
				entity_set_vector(knife, EV_VEC_angles, angles);
			}

			//entity_set_int(knife, EV_INT_movetype, MOVETYPE_NONE);
			//emit_sound(knife, CHAN_WEAPON, "weapons/knife_hitwall1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
		}
	}
	else return HAM_IGNORED;

	return HAM_HANDLED;
}

public _is_knife_kill(plugin, params)
{
	new id = get_param(1);
	if(params != 1 || is_user_alive(id))
		return ttt_log_to_file(LOG_ERROR, "Wrong number of params or user alive (ttt_is_knife_kill)");

	return g_iKilledByKnife[id];
}

public _knife_holding(plugin, params)
{
	if(params != 2)
		return ttt_log_to_file(LOG_ERROR, "Wrong number of params (ttt_knife_holding)");

	new id = get_param(1);
	if(get_param(2))
		return g_iHasTemp[id];

	return g_iHasKnife[id];
}

stock make_vacant(ent, Float:origin[3], &num, Float:radius)
{
	if(num++ > 100)
		return PLUGIN_CONTINUE;

	static Float:oldOrigin[3];
	entity_get_vector(ent, EV_VEC_origin, oldOrigin);

	for(new count; count < 3; count++)
	{
		if(count == 2)
			oldOrigin[count] += random_float(-160.0, 0.0);
		else oldOrigin[count] += random_float(-radius, radius);
	}

	if(PointContents(oldOrigin) != CONTENTS_EMPTY && PointContents(oldOrigin) != CONTENTS_SKY)
		return make_vacant(ent, origin, num, radius);

	entity_set_origin(ent, oldOrigin);
	if(drop_to_floor(ent))
		origin = oldOrigin;
	else return make_vacant(ent, origin, num, radius);

	return PLUGIN_HANDLED;
}

stock attack_post(id, knife, Float:flRate, Float:cvar)
{
	set_pdata_float(knife, m_flNextPrimaryAttack, flRate, 4);
	set_pdata_float(knife, m_flNextSecondaryAttack, flRate, 4);
	set_pdata_float(knife, m_flTimeWeaponIdle, flRate, 4);

	static Float:flPunchAngle[3];
	flPunchAngle[0] = cvar;

	entity_set_vector(id, EV_VEC_punchangle, flPunchAngle);
}

stock strip_knife(id, st, nd)
{
	g_iHasKnife[id] = st;
	g_iHasTemp[id] = nd;
	reset_user_knife(id);
}

stock reset_user_knife(id)
{
	if(user_has_weapon(id, CSW_KNIFE))
		ExecuteHamB(Ham_Item_Deploy, find_ent_by_owner(-1, "weapon_knife", id));

	engclient_cmd(id, "weapon_knife");
	UTIL_PlayWeaponAnimation(id, 3);

	emessage_begin(MSG_ONE, get_user_msgid("CurWeapon"), _, id);
	ewrite_byte(1);
	ewrite_byte(CSW_KNIFE);
	ewrite_byte(-1);
	emessage_end();
}

stock a_lot_of_blood(id)
{
	static iOrigin[3];
	get_user_origin(id, iOrigin);

	message_begin(MSG_PVS, SVC_TEMPENTITY, iOrigin);
	write_byte(TE_BLOODSTREAM);
	write_coord(iOrigin[0]);
	write_coord(iOrigin[1]);
	write_coord(iOrigin[2]+10);
	write_coord(random_num(-360, 360));
	write_coord(random_num(-360, 360));
	write_coord(-10);
	write_byte(70);
	write_byte(random_num(50, 100));
	message_end();

	new j;
	for(j = 0; j < 4; j++) 
	{
		message_begin(MSG_PVS, SVC_TEMPENTITY, iOrigin);
		write_byte(TE_WORLDDECAL);
		write_coord(iOrigin[0]+random_num(-100, 100));
		write_coord(iOrigin[1]+random_num(-100, 100));
		write_coord(iOrigin[2]-36);
		write_byte(random_num(190, 197));
		message_end();
	}
}

stock UTIL_PlayWeaponAnimation(const id, const seq)
{
	entity_set_int(id, EV_INT_weaponanim, seq);

	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, .player = id);
	write_byte(seq);
	write_byte(entity_get_int(id, EV_INT_body));
	message_end();
}

stock UTIL_SetRendering(ent, kRenderFx=kRenderFxNone, {Float,_}:fVecColor[3] = {0.0,0.0,0.0}, kRender=kRenderNormal, Float:flAmount=0.0)
{
	if(is_valid_ent(ent))
	{
		entity_set_int(ent, EV_INT_renderfx, kRenderFx);
		entity_set_vector(ent, EV_VEC_rendercolor, fVecColor);
		entity_set_int(ent, EV_INT_rendermode, kRender);
		entity_set_float(ent, EV_FL_renderamt, flAmount);
	}
}  