#include <amxmodx>
#include <fakemeta>
#include <engine>
#include <hamsandwich>
#include <cstrike>
#include <fun>
#include <ttt>

#if defined TTT_HAMBOTS
#include <cs_ham_bots_api>
#endif

#define OFFSET_LINUX_WEAPONS		4
#define m_iPlayer					41
#define m_flNextPrimaryAttack		46
#define m_flNextSecondaryAttack		47

#define WPN_WEAP "weapon_usp"
#define WPN_CSW CSW_USP

new const WPN_V_MODEL[] = "models/ttt/v_silencedusp.mdl";
new const WPN_P_MODEL[] = "models/ttt/p_silencedusp.mdl";
new const WPN_W_MODEL[] = "models/ttt/w_silencedusp.mdl";

new const m_rgpPlayerItems_CWeaponBox[6] = {34, 35, ...};

new const SECONDARY_WEAPONS_BITSUM = (1<<CSW_DEAGLE) | (1<<CSW_ELITE) | (1<<CSW_FIVESEVEN) | (1<<CSW_GLOCK18) | (1<<CSW_USP) | (1<<CSW_P228);

new cvar_usp_damage, cvar_usp_ammo, cvar_price_usp, cvar_usp_speed;
new g_iItem_USP, g_iBlood[2];
new g_iHasUSP[33], g_iKilledWith[33], g_iUSPEntID[33];

public plugin_precache()
{
	precache_model(WPN_V_MODEL);
	precache_model(WPN_P_MODEL);
	precache_model(WPN_W_MODEL);

	g_iBlood[0] = precache_model("sprites/blood.spr");
	g_iBlood[1] = precache_model("sprites/bloodspray.spr");
}

public plugin_init()
{
	register_plugin("[TTT] Item: Silent USP", TTT_VERSION, TTT_AUTHOR);

	RegisterHam(Ham_Killed, "player", "Ham_Killed_pre", 0);
	RegisterHam(Ham_TakeDamage, "player", "Ham_TakeDamage_pre", 0);
	RegisterHam(Ham_Weapon_SecondaryAttack, WPN_WEAP, "Ham_SecondaryAttack_pre", 0);

#if defined TTT_HAMBOTS
	RegisterHamBots(Ham_Killed, "Ham_Killed_pre", 0);
	RegisterHamBots(Ham_TakeDamage, "Ham_TakeDamage_pre", 0);
#endif

	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1");

	cvar_usp_damage		= register_cvar("ttt_usp_damage",	"2.0");
	cvar_usp_speed		= register_cvar("ttt_usp_speed",	"1.0");
	cvar_usp_ammo		= register_cvar("ttt_usp_ammo",		"100");
	cvar_price_usp		= register_cvar("ttt_price_usp",	"1");

	new name[TTT_ITEMNAME];
	formatex(name, charsmax(name), "%L", LANG_PLAYER, "TTT_ITEM_ID10");
	g_iItem_USP = ttt_buymenu_add(name, get_pcvar_num(cvar_price_usp), TRAITOR);
}

public plugin_natives()
{
	register_library("ttt");
	register_native("ttt_is_usp_kill", "_is_usp_kill");
}

public client_disconnect(id)
	reset_client(id);

public ttt_item_selected(id, item, name[], price)
{
	if(g_iItem_USP == item)
	{
		if(user_has_weapon(id, WPN_CSW))
			engclient_cmd(id, "drop", WPN_WEAP);

		give_weapon(id, 12, get_pcvar_num(cvar_usp_ammo));
		if(SECONDARY_WEAPONS_BITSUM & (1<<get_user_weapon(id)))
			engclient_cmd(id, WPN_WEAP);

		ColorChat(id, NORMAL, "%s %L", TTT_TAG, id, "TTT_ITEM2", name, id, "TTT_ITEM5");
		return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}

public give_weapon(id, clip, ammo)
{
	g_iUSPEntID[id] = give_item(id, WPN_WEAP);
	cs_set_weapon_silen(g_iUSPEntID[id], 1, 1);
	cs_set_weapon_ammo(g_iUSPEntID[id], clip);
	if(ammo) cs_set_user_bpammo(id, WPN_CSW, ammo);
	g_iHasUSP[id] = true;
}

public ttt_gamemode(gamemode)
{
	if(gamemode == ENDED || gamemode == RESTARTING)
	{
		new num, id;
		static players[32];
		get_players(players, num);
		for(--num; num >= 0; num--)
		{
			id = players[num];
			reset_client(id);
		}
	}
}

public ttt_touchweaponbox(ent, id, model[])
{
	if(!is_valid_ent(ent) || !is_user_alive(id))
		return PLUGIN_CONTINUE;

	static weapent;
	weapent = get_pdata_cbase(ent, m_rgpPlayerItems_CWeaponBox[2], OFFSET_LINUX_WEAPONS);
	if(weapent == -1)
		return PLUGIN_CONTINUE;

	if(equal(model, WPN_W_MODEL) && !g_iHasUSP[id])
	{
		g_iUSPEntID[id] = weapent;
		give_weapon(id, cs_get_weapon_ammo(weapent), 0);
		cs_set_weapon_silen(weapent, 1, 1);
		remove_entity(ent);

		return PLUGIN_HANDLED;
	}
	else if(!equal(model, WPN_WMODEL[2]) && g_iHasUSP[id] && !count_player_weaps(id, WPN_WEAP))
	{
		entity_set_int(ent, EV_INT_iuser4, 1);
		static weap[32];
		get_weaponname(cs_get_weapon_id(weapent), weap, charsmax(weap));

		static weapid;
		weapid = give_item(id, weap);
		cs_set_weapon_ammo(weapid, cs_get_weapon_ammo(weapent));
		cs_set_weapon_silen(weapent, 1, 1);
		remove_entity(ent);

		return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}

public ttt_setmodel(ent, model[])
{
	if(equal(model, WPN_WMODEL[2]))
	{
		static owner;
		owner = entity_get_edict(ent, EV_ENT_owner);
		if(g_iHasUSP[owner])
		{
			entity_set_model(ent, WPN_W_MODEL);
			g_iHasUSP[owner] = false;
			g_iUSPEntID[owner] = false;
			return TTT_SUPERCEDE;
		}
	}

	return TTT_IGNORED;
}

public Event_CurWeapon(id)
{
	if(id == entity_get_int(id, EV_INT_iuser2))
		return;

	if(read_data(2) == WPN_CSW && g_iHasUSP[id] && read_data(1))
	{
		new ent = find_ent_by_owner(-1, WPN_WEAP, id);
		if(ent == g_iUSPEntID[id])
		{
			entity_set_string(id, EV_SZ_viewmodel, WPN_V_MODEL);
			entity_set_string(id, EV_SZ_weaponmodel, WPN_P_MODEL);

			new Float:speed, Float:delay;
			speed = get_pcvar_float(cvar_usp_speed);
			delay = get_pdata_float(ent, m_flNextPrimaryAttack, OFFSET_LINUX_WEAPONS) * speed;

			if(delay > 0.0)
				set_pdata_float(ent, m_flNextPrimaryAttack, delay, OFFSET_LINUX_WEAPONS);
		}
	}
}

public Ham_Killed_pre(victim, killer, shouldgib)
{
	if(!is_user_connected(victim) || !is_user_connected(killer) || ttt_get_game_state() == OFF || ttt_get_game_state() == ENDED)
		return HAM_IGNORED;

	if(get_user_weapon(killer) == WPN_CSW && g_iHasUSP[killer])
		g_iKilledWith[victim] = true;

	if(g_iHasUSP[victim])
		engclient_cmd(victim, "drop", WPN_WEAP);

	return HAM_HANDLED;
}

public Ham_SecondaryAttack_pre(ent)
{
	new id = get_pdata_cbase(ent, m_iPlayer, OFFSET_LINUX_WEAPONS);
	if(is_user_alive(id) && !cs_get_user_shield(id) && g_iHasUSP[id])
	{
		set_pdata_float(ent, m_flNextSecondaryAttack, 9999.0, OFFSET_LINUX_WEAPONS);
		return HAM_SUPERCEDE;
	}

	return HAM_IGNORED;
}

public Ham_TakeDamage_pre(victim, inflictor, attacker, Float:damage)
{
	if(victim != attacker && is_user_connected(attacker) && get_user_weapon(attacker) == WPN_CSW)
	{
		if(g_iHasUSP[attacker])
		{
			SetHamParamFloat(4, damage * get_pcvar_float(cvar_usp_damage));
			return HAM_HANDLED;
		}
	}

	return HAM_IGNORED;
}

public _is_usp_kill(plugin, params)
{
	new id = get_param(1);
	if(params != 1 || is_user_alive(id))
		return ttt_log_to_file(LOG_ERROR, "Wrong number of params or user alive (ttt_is_usp_kill)");

	return g_iKilledWith[id];
}

stock reset_client(id)
{
	g_iHasUSP[id] = false;
	g_iUSPEntID[id] = false;
	g_iKilledWith[id] = false;
}

stock count_player_weaps(id, exception[])
{
	static const sSecondaryWeapons[][] = {"weapon_p228", "weapon_elite", "weapon_fiveseven", "weapon_usp", "weapon_glock18", "weapon_deagle"};
	new i, count, ent;
	for(i = 0; i < sizeof(sSecondaryWeapons); i++)
	{
		if(equal(exception, sSecondaryWeapons[i]))
			continue;

		if((ent = find_ent_by_owner(-1, sSecondaryWeapons[i], id)))
		{
			if(!entity_get_int(ent, EV_INT_iuser4))
				count++;
		}
	}

	return count;
}