#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <engine>
#include <cstrike>
#include <fun>
#include <ttt>

#if defined TTT_HAMBOTS
#include <cs_ham_bots_api>
#endif

#define WPN_CSW CSW_UMP45
#define WPN_WEAP "weapon_ump45"

#define m_flNextPrimaryAttack	46
#define OFFSET_LINUX_WEAPONS	4

new const m_rgpPlayerItems_CWeaponBox[6] = {34, 35, ...};
new const WPN_V_MODEL[] = "models/ttt/v_ump.mdl";
new const WPN_P_MODEL[] = "models/ttt/p_ump.mdl";
new const WPN_W_MODEL[] = "models/ttt/w_ump.mdl";

new cvar_ump_ammo, cvar_ump_speed, cvar_price_ump, g_iItem_UMP;
new g_iHasUMP[33], g_iUMPEntID[33];

public plugin_precache()
{
	precache_model(WPN_V_MODEL);
	precache_model(WPN_P_MODEL);
	precache_model(WPN_W_MODEL);
}

public plugin_init()
{
	register_plugin("[TTT] Item: UMP Prototype", TTT_VERSION, TTT_AUTHOR);

	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1");
	register_forward(FM_SetModel, "Forward_SetModel");

	RegisterHam(Ham_TakeDamage, "player", "Ham_TakeDamage_pre", 0);
	RegisterHam(Ham_Killed, "player", "Ham_Killed_pre", 0);

#if defined TTT_HAMBOTS
	RegisterHamBots(Ham_TakeDamage, "Ham_TakeDamage_pre", 0);
	RegisterHamBots(Ham_Killed, "Ham_Killed_pre", 0);
#endif

	cvar_ump_ammo = register_cvar("ttt_ump_ammo", "100");
	cvar_ump_speed = register_cvar("ttt_ump_speed", "10.0");
	cvar_price_ump = register_cvar("ttt_price_ump", "1");

	new name[TTT_ITEMNAME];
	formatex(name, charsmax(name), "%L", LANG_PLAYER, "TTT_ITEM_ID6");
	g_iItem_UMP = ttt_buymenu_add(name, get_pcvar_num(cvar_price_ump), DETECTIVE);
}

public client_disconnect(id)
{
	g_iHasUMP[id] = false;
	g_iUMPEntID[id] = false;
}

public ttt_item_selected(id, item, name[], price)
{
	if(g_iItem_UMP == item)
	{
		if(user_has_weapon(id, WPN_CSW))
			engclient_cmd(id, "drop", WPN_WEAP);

		give_weapon(id, 25, get_pcvar_num(cvar_ump_ammo));
		ColorChat(id, NORMAL, "%s %L", TTT_TAG, id, "TTT_ITEM2", name, id, "TTT_ITEM5");
		return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}

public give_weapon(id, clip, ammo)
{
	g_iUMPEntID[id] = give_item(id, WPN_WEAP);
	cs_set_weapon_ammo(g_iUMPEntID[id], clip);
	if(ammo) cs_set_user_bpammo(id, WPN_CSW, ammo);
	g_iHasUMP[id] = true;
}

public ttt_gamemode(gamemode)
{
	if(gamemode == ENDED || gamemode == RESTARTING)
	{
		new num, id;
		static players[32];
		get_players(players, num);
		for(--num; num >= 0; num--)
		{
			id = players[num];
			g_iHasUMP[id] = false;
			g_iUMPEntID[id] = false;
		}
	}
}

public ttt_touchweaponbox(ent, id, model[])
{
	if(!is_valid_ent(ent) || !is_user_alive(id))
		return PLUGIN_CONTINUE;

	static weapent;
	weapent = get_pdata_cbase(ent, m_rgpPlayerItems_CWeaponBox[1], OFFSET_LINUX_WEAPONS);
	if(weapent == -1)
		return PLUGIN_CONTINUE;

	if(equal(model, WPN_W_MODEL) && !g_iHasUMP[id])
	{
		g_iUMPEntID[id] = weapent;
		give_weapon(id, cs_get_weapon_ammo(weapent), 0);
		remove_entity(ent);

		return PLUGIN_HANDLED;
	}
	else if(!equal(model, WPN_WMODEL[1]) && g_iHasUMP[id] && !count_player_weaps(id, WPN_WEAP))
	{
		entity_set_int(weapent, EV_INT_iuser4, 1);
		static weap[32];
		get_weaponname(cs_get_weapon_id(weapent), weap, charsmax(weap));

		static weapid;
		weapid = give_item(id, weap);
		cs_set_weapon_ammo(weapid, cs_get_weapon_ammo(weapent));
		remove_entity(ent);

		return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}

public ttt_setmodel(ent, model[])
{
	if(equal(model, WPN_WMODEL[1]))
	{
		static owner;
		owner = entity_get_edict(ent, EV_ENT_owner);
		if(g_iHasUMP[owner])
		{
			entity_set_model(ent, WPN_W_MODEL);
			g_iHasUMP[owner] = false;
			g_iUMPEntID[owner] = false;
			return TTT_SUPERCEDE;
		}
	}

	return TTT_IGNORED;
}

public Ham_Killed_pre(victim, killer, shouldgib)
{
	if(ttt_return_check(victim))
		return HAM_IGNORED;

	if(g_iHasUMP[victim])
	{
		engclient_cmd(victim, "drop", WPN_WEAP);
		return HAM_HANDLED;
	}

	return HAM_IGNORED;
}

public Ham_TakeDamage_pre(victim, inflictor, attacker, Float:damage)
{
	if(is_user_alive(attacker) && is_user_alive(victim) && get_user_weapon(attacker) == WPN_CSW)
	{
		if(g_iHasUMP[attacker])
		{
			new Float:angles[3];
			entity_get_vector(victim, EV_VEC_angles, angles);

			angles[0] += random_float(-damage, damage);
			angles[1] += random_float(-damage, damage);
			entity_set_vector(victim, EV_VEC_angles, angles);

			angles[2] += random_float(-damage, damage);
			entity_set_vector(victim, EV_VEC_punchangle, angles);

			entity_set_int(victim, EV_INT_fixangle, 1);
			SetHamParamFloat(4, 0.0);
			return HAM_HANDLED;
		}
	}

	return HAM_IGNORED;
}

public Event_CurWeapon(id)
{
	if(id == entity_get_int(id, EV_INT_iuser2))
		return;

	if(read_data(2) == WPN_CSW && g_iHasUMP[id] && read_data(1))
	{
		new ent = find_ent_by_owner(-1, WPN_WEAP, id);
		if(ent == g_iUMPEntID[id])
		{
			entity_set_string(id, EV_SZ_viewmodel, WPN_V_MODEL);
			entity_set_string(id, EV_SZ_weaponmodel, WPN_P_MODEL);

			new Float:speed, Float:delay;
			speed = get_pcvar_float(cvar_ump_speed);
			delay = get_pdata_float(ent, m_flNextPrimaryAttack, OFFSET_LINUX_WEAPONS) * speed;

			if(delay > 0.0)
				set_pdata_float(ent, m_flNextPrimaryAttack, delay, OFFSET_LINUX_WEAPONS);
		}
	}
}

stock count_player_weaps(id, exception[])
{
	static const szPrimaryWeapons[][] =
	{
		"weapon_scout", "weapon_xm1014", "weapon_mac10", "weapon_aug", "weapon_ump45", "weapon_sg550", "weapon_galil",
		"weapon_famas", "weapon_awp", "weapon_mp5navy",	"weapon_m249", "weapon_m3", "weapon_m4a1", "weapon_tmp", "weapon_g3sg1",
		"weapon_sg552", "weapon_ak47", "weapon_p90"
	};

	new i, count, ent;
	for(i = 0; i < sizeof(szPrimaryWeapons); i++)
	{
		if(equal(exception, szPrimaryWeapons[i]))
			continue;

		if((ent = find_ent_by_owner(-1, szPrimaryWeapons[i], id)))
		{
			if(!entity_get_int(ent, EV_INT_iuser4))
				count++;
		}
	}

	return count;
}