#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <cstrike>
#include <fun>
#include <ttt>

new const g_sPriWeap[][] = 
{
	"weapon_scout",
	"weapon_xm1014",
	"weapon_mac10",
	"weapon_ump45",
	"weapon_m249",
	"weapon_m3",
	"weapon_tmp",
	"weapon_p90"
};

new const g_sPriAmmoType[][] =
{
	"762nato",
	"buckshot",
	"45acp",
	"45acp",
	"556natobox",
	"buckshot",
	"9mm", 
	"57mm"
};

new const g_sSecWeap[][] = 
{
	"weapon_p228",
	"weapon_elite",
	"weapon_fiveseven",
	"weapon_glock18",
	"weapon_deagle"
};

new const g_sSecAmmoType[][] = 
{
	"357sig",
	"9mm",
	"57mm",
	"9mm",
	"50ae"
};

new const g_sPriAmmo[] = 
{
	90,
	32,
	100,
	100,
	200,
	32,
	120,
	100
};

new const g_sSecAmmo[] = 
{
	52,
	120,
	100,
	120,
	35
};

const PRIMARY_WEAPONS_BIT_SUM = (1<<CSW_SCOUT)|(1<<CSW_XM1014)|(1<<CSW_MAC10)|(1<<CSW_AUG)|(1<<CSW_UMP45)|(1<<CSW_SG550)|(1<<CSW_GALIL)|(1<<CSW_FAMAS)|
	(1<<CSW_AWP)|(1<<CSW_MP5NAVY)|(1<<CSW_M249)|(1<<CSW_M3)|(1<<CSW_M4A1)|(1<<CSW_TMP)|(1<<CSW_G3SG1)|(1<<CSW_SG552)|(1<<CSW_AK47)|(1<<CSW_P90);
const SECONDARY_WEAPONS_BIT_SUM = (1<<CSW_P228)|(1<<CSW_ELITE)|(1<<CSW_FIVESEVEN)|(1<<CSW_USP)|(1<<CSW_GLOCK18)|(1<<CSW_DEAGLE);
const GRENADES_WEAPONS_BIT_SUM = (1<<CSW_HEGRENADE)|(1<<CSW_FLASHBANG)|(1<<CSW_SMOKEGRENADE)|(1<<CSW_C4);

public plugin_init()
{
	register_plugin("[TTT] Random weapon", TTT_VERSION, TTT_AUTHOR);
	RegisterHam(Ham_Spawn, "player", "Ham_Spawn_post", 1);
}

public Ham_Spawn_post(id)
{
	if(is_user_alive(id) && (ttt_get_game_state() == PREPARING || ttt_get_game_state() == UNSET))
		give_random_weap(id);
}

public give_random_weap(id)
{
	strip_weapons(id);

	new iPri = random_num(0, charsmax(g_sPriWeap));
	new iSec = random_num(0, charsmax(g_sSecWeap));

	give_item(id, g_sPriWeap[iPri]);
	give_item(id, g_sSecWeap[iSec]);

	if(task_exists(id))
		remove_task(id);

	set_task(get_pcvar_num(get_cvar_pointer("ttt_preparation_time"))+10.0, "give_nade", id);
	ExecuteHamB(Ham_GiveAmmo, id, g_sPriAmmo[iPri], g_sPriAmmoType[iPri], g_sPriAmmo[iPri]);
	ExecuteHamB(Ham_GiveAmmo, id, g_sSecAmmo[iSec], g_sSecAmmoType[iSec], g_sSecAmmo[iSec]);
}

public give_nade(id)
	if(is_user_alive(id))
		give_item(id, "weapon_hegrenade");

stock strip_weapons(id)
{
	new weapons[32], num_weapons, index, weaponid;
	get_user_weapons(id, weapons, num_weapons);

	for (index = 0; index < num_weapons; index++)
	{
		weaponid = weapons[index];
		
		if(((1<<weaponid) & PRIMARY_WEAPONS_BIT_SUM) || ((1<<weaponid) & SECONDARY_WEAPONS_BIT_SUM) || ((1<<weaponid) & GRENADES_WEAPONS_BIT_SUM))
		{
			new wname[32];
			get_weaponname(weaponid, wname, charsmax(wname));

			ham_strip_weapon(id, wname);
			cs_set_user_bpammo(id, weaponid, 0);
		}
	}
}

stock ham_strip_weapon(index, const weapon[])
{
	new weaponid = get_weaponid(weapon);
	if(!weaponid)
		return false;

	new weapon_ent = fm_find_ent_by_owner(-1, weapon, index);
	if (!weapon_ent)
		return false;

	new current_weapon_ent = fm_cs_get_current_weapon_ent(index);
	new current_weapon = pev_valid(current_weapon_ent) ? cs_get_weapon_id(current_weapon_ent) : -1;
	if(current_weapon == weaponid)
		ExecuteHamB(Ham_Weapon_RetireWeapon, weapon_ent);

	if (!ExecuteHamB(Ham_RemovePlayerItem, index, weapon_ent))
		return false;

	ExecuteHamB(Ham_Item_Kill, weapon_ent);
	set_pev(index, pev_weapons, pev(index, pev_weapons) & ~(1<<weaponid));

	return true;
}

stock fm_find_ent_by_owner(entity, const classname[], owner)
{
	while ((entity = engfunc(EngFunc_FindEntityByString, entity, "classname", classname)) && pev(entity, pev_owner) != owner) { /* keep looping */ }
	return entity;
}

stock fm_cs_get_current_weapon_ent(id)
{
	if(pev_valid(id) != 2)
		return -1;

	return get_pdata_cbase(id, 373);
}