#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <engine>
#include <cstrike>
#include <fun>
#include <ttt>

#if defined TTT_HAMBOTS
#include <cs_ham_bots_api>
#endif

new const g_sCrowbarModel[][] = {"models/ttt/p_crowbar.mdl", "models/ttt/v_crowbar.mdl"};
new const g_szGrenadeModel[][] = {"models/ttt/p_hegrenade.mdl", "models/ttt/v_hegrenade.mdl", "models/ttt/w_hegrenade.mdl"};
new const g_sCrowbarSound[][] = {"weapons/cbar_hitbod2.wav", "weapons/cbar_hitbod1.wav", "weapons/bullet_hit2.wav",  "weapons/cbar_miss1.wav"};
new const g_sHeadShotSound[][] = {"player/headshot1.wav", "player/headshot2.wav", "player/headshot3.wav"};

new const g_sWeaponsList[][] = 
{
	"weapon_p228", "weapon_scout", "weapon_hegrenade", "weapon_xm1014", "weapon_c4", "weapon_mac10", "weapon_aug",
	"weapon_elite", "weapon_fiveseven",	"weapon_ump45", "weapon_sg550", "weapon_galil", "weapon_famas", "weapon_usp", "weapon_glock18",
	"weapon_awp", "weapon_mp5navy", "weapon_m249", "weapon_m3",	"weapon_m4a1", "weapon_tmp", "weapon_g3sg1",
	"weapon_deagle", "weapon_sg552", "weapon_ak47", "weapon_knife", "weapon_p90"
};

new const g_sBlockSet[][] =
{
	"BombDrop",
	"BombPickup",
	"DeathMsg",
	"ScoreInfo",
	"Radar",
	"Money"
};

new const g_sMessageBlock[][] =
{
	"ScoreAttrib",
	"TextMsg",
	"SendAudio",
	"Scenario",
	"StatusIcon"
};

public plugin_precache()
{
	new i;
	for(i = 0; i <= charsmax(g_sCrowbarModel); i++)
		precache_model(g_sCrowbarModel[i]);

	for(i = 0; i <= charsmax(g_szGrenadeModel); i++)
		precache_model(g_szGrenadeModel[i]);

	for(i = 0; i <= charsmax(g_sCrowbarSound); i++)
		precache_sound(g_sCrowbarSound[i]);

	for(i = 0; i <= charsmax(g_sHeadShotSound); i++)
		precache_sound(g_sHeadShotSound[i]);
}

public plugin_init()
{
	register_plugin("[TTT] Replacements", TTT_VERSION, TTT_AUTHOR);

	new i;
	for(i = 0; i <= charsmax(g_sBlockSet); i++)
		set_msg_block(get_user_msgid(g_sBlockSet[i]), BLOCK_SET);

	for(i = 0; i <= charsmax(g_sMessageBlock); i++)
		register_message(get_user_msgid(g_sMessageBlock[i]), "Message_Block");

	register_forward(FM_EmitSound, "Forward_EmitSound");
	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1");

	for(i = 0; i <= charsmax(g_sWeaponsList); i++)
	{
		RegisterHam(Ham_Weapon_PrimaryAttack, g_sWeaponsList[i], "Ham_BlockWeapon_post", 1);
		RegisterHam(Ham_Weapon_SecondaryAttack, g_sWeaponsList[i], "Ham_BlockWeapon_post", 1);
		RegisterHam(Ham_Item_Deploy, g_sWeaponsList[i], "Ham_BlockWeapon_post", 1);
	}
	RegisterHam(Ham_Spawn, "player", "Ham_Spawn_post", 1);

#if defined TTT_HAMBOTS
	RegisterHamBots(Ham_Spawn, "Ham_Spawn_post", 1);
#endif
}

public Message_Block(msgid, dest, id)
{
	if(get_msg_args() > 1)
	{
		static message[128];
		if(get_msg_args() == 5)
			get_msg_arg_string(5, message, charsmax(message));

		if(equal(message, "#Fire_in_the_hole"))
			return PLUGIN_HANDLED;

		get_msg_arg_string(2, message, charsmax(message));
		if(equal(message, "%!MRAD_BOMBPL") || equal(message, "%!MRAD_BOMBDEF") || equal(message, "%!MRAD_terwin") || equal(message, "%!MRAD_ctwin") || equal(message, "%!MRAD_FIREINHOLE"))
			return PLUGIN_HANDLED;

		if(equal(message, "#Killed_Teammate") || equal(message, "#Game_teammate_kills") || equal(message, "#Game_teammate_attack") || equal(message, "#C4_Plant_At_Bomb_Spot"))
			return PLUGIN_HANDLED;

		if(equal(message, "#Bomb_Planted") || equal(message, "#Game_bomb_drop") || equal(message, "#Game_bomb_pickup") || equal(message, "#Got_bomb") || equal(message, "#C4_Plant_Must_Be_On_Ground"))
			return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}

public Forward_EmitSound(id, channel, sample[])
{
	if(!is_user_connected(id))
		return FMRES_IGNORED;

	if(equal(sample, "player/bhit_helmet-1.wav"))
	{
		emit_sound(id, CHAN_BODY, g_sHeadShotSound[random_num(0, 2)], 1.0, ATTN_NORM, 0, PITCH_NORM);
		return FMRES_SUPERCEDE;
	}

	if((equal(sample, "player/die", 10) || equal(sample, "player/death6.wav")) && (!is_user_alive(id) && (ttt_is_knife_kill(id) || ttt_is_usp_kill(id))))
		return FMRES_SUPERCEDE;
	
	if(equal(sample, "weapons/knife_", 14))
	{
		new knife = ttt_knife_holding(id, 0), temp = ttt_knife_holding(id, 1);
		if(!knife && (!temp || temp))
		{
			switch(sample[17])
			{
				case('b'): emit_sound(id, CHAN_WEAPON, g_sCrowbarSound[0], 1.0, ATTN_NORM, 0, PITCH_NORM);
				case('w'): emit_sound(id, CHAN_WEAPON, g_sCrowbarSound[1], 1.0, ATTN_NORM, 0, PITCH_LOW);
				case('s'): emit_sound(id, CHAN_WEAPON, g_sCrowbarSound[3], 1.0, ATTN_NORM, 0, PITCH_NORM);
				case('1', '2'): emit_sound(id, CHAN_WEAPON, g_sCrowbarSound[2], random_float(0.5, 1.0), ATTN_NORM, 0, PITCH_NORM);
			}
			return FMRES_SUPERCEDE;
		}
	}

	return FMRES_IGNORED;
}

public Ham_Spawn_post(id)
{
	if(is_user_alive(id))
	{
		static model[20];
		cs_get_user_model(id, model, charsmax(model));

		if(!equal(model, TTT_PLAYER_MODEL))
			cs_set_user_model(id, TTT_PLAYER_MODEL);
	}
}

public Ham_BlockWeapon_post(const ent)
{
	if(ttt_get_game_state() == PREPARING)
	{
		new Float:time = get_roundtime()*(-1.0);
		set_pdata_float(ent, 46, time, 4);
		set_pdata_float(ent, 47, time, 4);
	}
}

public ttt_setmodel(ent, model[])
{
	if(equal(model, WPN_WMODEL[3]))
	{
		if(entity_get_float(ent, EV_FL_dmgtime) != 0.0)
		{
			entity_set_model(ent, g_szGrenadeModel[2]);
			return TTT_SUPERCEDE;
		}
	}

	return TTT_IGNORED;
}

public Event_CurWeapon(id)
{
	if(!is_user_alive(id))
		return;

	if(get_user_weapon(id) == CSW_KNIFE)
	{
		entity_set_string(id, EV_SZ_viewmodel, g_sCrowbarModel[1]);
		entity_set_string(id, EV_SZ_weaponmodel, g_sCrowbarModel[0]);
	}

	if(get_user_weapon(id) == CSW_HEGRENADE)
	{
		entity_set_string(id, EV_SZ_viewmodel, g_szGrenadeModel[1]);
		entity_set_string(id, EV_SZ_weaponmodel, g_szGrenadeModel[0]);
	}
}