#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <engine>
#include <fun>
#include <ttt>
#include <round_terminator>

#if defined TTT_HAMBOTS
#include <cs_ham_bots_api>
#endif

#define TASK_ROUNDEND 1111

new g_iWonGame;
new g_iWonScore[Special], g_iWonForward, cvar_karma_win;

new const g_sWinSounds[][] = 
{
	"",
	"ttt/win_traitors.wav",
	"ttt/win_innocent.wav"
};

new const g_sWinner[][] =
{
	"",
	"TTT_TWIN",
	"TTT_IWIN"
};

public plugin_precache()
{
	new i;
	for(i = 1; i <= charsmax(g_sWinSounds); i++)
		precache_sound(g_sWinSounds[i]);
}

public plugin_init()
{
	register_plugin("[TTT] Round winner", TTT_VERSION, TTT_AUTHOR);

	cvar_karma_win = register_cvar("ttt_karma_win", "20");
	register_message(get_user_msgid("TextMsg"), "Message_Winner");

	RegisterHam(Ham_Spawn, "player", "Ham_Spawn_post", 1);

#if defined TTT_HAMBOTS
	RegisterHamBots(Ham_Spawn,  "Ham_Spawn_post", 1);
#endif

	g_iWonForward = CreateMultiForward("ttt_winner", ET_IGNORE, FP_CELL);
	//register_clcmd("say rr", "End_Round_False");
}

public plugin_natives()
{
	register_library("ttt");
	register_native("ttt_get_winner", "_get_winner");
	register_native("ttt_set_winner", "_set_winner");
}

public ttt_gamemode(gamemode)
{
	if(gamemode != STARTED && task_exists(TASK_ROUNDEND))
		remove_task(TASK_ROUNDEND);

	switch(gamemode)
	{
		case RESTARTING:
		{
			g_iWonGame = false;
			g_iWonScore[DETECTIVE] = 0;
			g_iWonScore[TRAITOR] = 0;
		}
		case PREPARING: set_task(floatmul(get_pcvar_float(get_cvar_pointer("mp_roundtime")), 60.0) + get_pcvar_float(get_cvar_pointer("ttt_preparation_time")), "End_Round_False", TASK_ROUNDEND);
	}

	set_task(0.2, "Update_Scores");
}

public client_disconnect(id)
{
	if(get_winner(0) && ttt_get_game_state() == STARTED)
		End_Round_False();
}

public client_putinserver(id)
{
	if(ttt_get_game_state() == OFF || ttt_get_game_state() == UNSET)
	{
		new total, alive;
		static players[32];
		get_players(players, total);
		get_players(players, alive, "a");

		if(total > 2 || alive == 1)
			set_pcvar_num(get_cvar_pointer("sv_restartround"), 3);
	}
}

public Ham_Spawn_post(id)
{
	if(ttt_get_game_state() == PREPARING && is_user_alive(id))
		set_user_godmode(id, 1);
}

public End_Round_False()
{
	if(ttt_get_game_state() == STARTED || ttt_get_game_state() == OFF || ttt_get_game_state() == UNSET)
	{
		#if !defined TTT_HAMBOTS
		//g_iWonGame = DETECTIVE;
		//g_iWonScore[DETECTIVE]++;
		TerminateRound(RoundEndType_TeamExtermination, DETECTIVE, MapType_Bomb);
		#endif
	}
}

public get_winner(type)
{
	new who, num;
	static players[32];

	get_players(players, num, "a");
	if(num <= 0)
		who = TRAITOR;
	else if(ttt_get_special_count(DETECTIVE) == 0 && ttt_get_special_count(INNOCENT) == 0)
		who = TRAITOR;
	else if(ttt_get_special_count(TRAITOR) == 0)
		who = DETECTIVE;

	if(who > 0 && type)
	{
		new id, specstate;
		for(--num; num >= 0; num--)
		{
			id = players[num];
			specstate = ttt_get_special_state(id);
			if(specstate == who || (who == DETECTIVE && specstate == INNOCENT))
				ttt_set_playerdata(id, PD_KARMATEMP, ttt_get_playerdata(id, PD_KARMATEMP)+get_pcvar_num(cvar_karma_win));
		}
	}
	return who;
}

public Message_Winner(msgid, dest, id)
{
	if(ttt_get_game_state() != STARTED || g_iWonGame)
		return PLUGIN_CONTINUE;

	static message[20];
	get_msg_arg_string(2, message, charsmax(message));
	if(equal(message, "#Terrorists_Win") || equal(message, "#CTs_Win"))
	{
		new who;
		get_winner(1);
		if(equal(message, "#Terrorists_Win"))
			who = TRAITOR;
		else if(equal(message, "#CTs_Win"))
			who = DETECTIVE;
	
		if(!who)
			who = get_winner(0);
	
		if(who)
		{
			g_iWonGame = who;
			g_iWonScore[who]++;
			static out[32];
			formatex(out, charsmax(out), "%L", LANG_PLAYER, g_sWinner[g_iWonGame]);
			set_msg_arg_string(2, out);
			client_cmd(0, "spk ^"%s^"", g_sWinSounds[g_iWonGame]);
			//emit_sound(0, CHAN_AUTO, g_sWinSounds[g_iWonGame], VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	
			new ret;
			ExecuteForward(g_iWonForward, ret, g_iWonGame);
			//ttt_set_game_state(ENDED);
			
			return PLUGIN_HANDLED;
		}
	}

	return PLUGIN_CONTINUE;
}

public Update_Scores()
{
	new msg = get_user_msgid("TeamScore");

	message_begin(MSG_BROADCAST, msg, _, 0);
	write_string("TERRORIST");
	write_short(g_iWonScore[TRAITOR]);
	message_end();

	message_begin(MSG_BROADCAST, msg, _, 0);
	write_string("CT");
	write_short(g_iWonScore[DETECTIVE]);
	message_end();

	g_iWonGame = false;
}

public _get_winner()
{
	return g_iWonGame;
}

public _set_winner(plugin, params)
{
	if(params != 1)
		return ttt_log_to_file(LOG_ERROR, "Wrong number of params (ttt_set_winner)");

	new team = get_param(1);
	if(team != TRAITOR && team != DETECTIVE)
		return ttt_log_to_file(LOG_ERROR, "Team isn't Traitor or Detective (ttt_set_winner)");

	g_iWonGame = team;
	g_iWonScore[team]++;

	TerminateRound(RoundEndType_TeamExtermination, team);
	
	return 1;
}