#include <amxmodx>
#include <sqlx>
#include <ttt>

new const g_iPointValue[Stats-1] =
{
	100,
	150,
	100,
	-100,
	10,
	10,
	10,
	50,
	50,
	50
};

new g_iPlayerStats[33][Stats], g_szPlayerName[33][32], cvar_stats, pluginon;
new Handle:g_pSqlTuple;
new g_szError[512];

public plugin_init()
{
	register_plugin("[TTT] Stats System", TTT_VERSION, TTT_AUTHOR);

	cvar_stats = register_cvar("ttt_stats", "0");
	pluginon = get_pcvar_num(cvar_stats);
}

public plugin_cfg()
	set_task(1.0, "check_plugin");

public check_plugin()
{
	pluginon = get_pcvar_num(cvar_stats);
	if(pluginon)
		MySQL_Init();
}

public plugin_natives()
{
	register_library("ttt");
	register_native("ttt_set_player_stat", "_set_player_stat");
	register_native("ttt_get_player_stat", "_get_player_stat");
}

public plugin_end()
{
	if(pluginon)
		SQL_FreeHandle(g_pSqlTuple);
}

public client_putinserver(id)
{
	if(pluginon)
	{
		reset_client(id);
		get_user_name(id, g_szPlayerName[id], charsmax(g_szPlayerName[]));
		escape_mysql(g_szPlayerName[id], charsmax(g_szPlayerName[]));
		MySQL_Load(id);
	}
}

public client_disconnect(id)
{
	if(pluginon)
	{
		MySQL_Save(id);
		reset_client(id);
	}
}

public MySQL_Init()
{
	static host[64], user[33], pass[32], db[32];
	get_cvar_string("amx_sql_host", host, charsmax(host));
	get_cvar_string("amx_sql_user", user, charsmax(user));
	get_cvar_string("amx_sql_pass", pass, charsmax(pass));
	get_cvar_string("amx_sql_db", db, charsmax(db));

	g_pSqlTuple = SQL_MakeDbTuple(host, user, pass, db);

	new errorCode, Handle:SqlConnection = SQL_Connect(g_pSqlTuple, errorCode, g_szError, charsmax(g_szError));
	if(SqlConnection == Empty_Handle)
		set_fail_state(g_szError);

	new Handle:queries = SQL_PrepareQuery(SqlConnection, "CREATE TABLE IF NOT EXISTS ttt_stats (id int(8) unsigned NOT NULL auto_increment, player_name varchar(33) UNIQUE NOT NULL default '', gwk int(10), kills_i int(10), kills_d int(10), kills_t int(10), rdm int(10), innocent int(15), detective int(10), traitor int(10), bomb_planted int(10), bomb_exploded int(10), bomb_defused int(10), total_points int(32), PRIMARY KEY (id))");

	if(!SQL_Execute(queries))
	{
		SQL_QueryError(queries, g_szError, charsmax(g_szError));
		set_fail_state(g_szError);
	}

	SQL_FreeHandle(queries);
	SQL_FreeHandle(SqlConnection); 
}

public MySQL_Load(id)
{
	new data[2];
	data[0] = id;

	static temp[512];
	format(temp, charsmax(temp), "SELECT * FROM ttt_stats WHERE player_name = '%s'", g_szPlayerName[id]);
	SQL_ThreadQuery(g_pSqlTuple, "register_client", temp, data, 1);
}

public MySQL_Save(id)
{
	count_points(id);
	static temp[512];
	format(temp, charsmax(temp), "UPDATE ttt_stats SET gwk = '%d', kills_i = '%d', kills_d = '%d', kills_t = '%d', rdm = '%d', innocent = '%d', detective = '%d', traitor = '%d', bomb_planted = '%d', bomb_exploded = '%d', bomb_defused = '%d', total_points = '%d' WHERE player_name = '%s'",
	g_iPlayerStats[id][STATS_GWK], g_iPlayerStats[id][STATS_KILLS_I], g_iPlayerStats[id][STATS_KILLS_D], g_iPlayerStats[id][STATS_KILLS_T], g_iPlayerStats[id][STATS_RDM], g_iPlayerStats[id][STATS_INN], g_iPlayerStats[id][STATS_DET], g_iPlayerStats[id][STATS_TRA], g_iPlayerStats[id][STATS_BOMBP], g_iPlayerStats[id][STATS_BOMBE], g_iPlayerStats[id][STATS_BOMBD], g_iPlayerStats[id][STATS_POINTS], g_szPlayerName[id]);

	SQL_ThreadQuery(g_pSqlTuple, "IgnoreHandle", temp);
}

public register_client(failstate, Handle:query, error[], errcode, data[], datasize)
{
	if(failstate == TQUERY_CONNECT_FAILED)
		log_amx("%s Load - Could not connect to SQL database.  [%d] %s", TTT_TAG, errcode, error);
	else if(failstate == TQUERY_QUERY_FAILED)
		log_amx("%s Load query failed. [%d] %s", TTT_TAG, errcode, error);

	new id = data[0];
	if(!is_user_connected(id))
		return PLUGIN_HANDLED;

	if(SQL_NumResults(query) > 0) 
	{
		new i;
		for(i = 0; i < Stats; i++)
			g_iPlayerStats[id][i] = SQL_ReadResult(query, i+2);
	}
	else table_insert(id);

	return PLUGIN_HANDLED;
}

public IgnoreHandle(failstate, Handle:query, error[], errcode, data[], datasize)
{
	SQL_FreeHandle(query);
	return PLUGIN_HANDLED;
}

stock reset_client(id)
{
	new i;
	for(i = 0; i < Stats-1; i++)
		g_iPlayerStats[id][i] = 0;
}

stock count_points(id)
{
	new i, points;
	for(i = 0; i < Stats-1; i++)
		points += (g_iPlayerStats[id][i] * g_iPointValue[i]);

	g_iPlayerStats[id][STATS_POINTS] = points;
}

stock table_insert(id)
{
	static temp[512];
	format(temp, charsmax(temp), "INSERT INTO ttt_stats (player_name, gwk, kills_i, kills_d, kills_t, rdm, innocent, detective, traitor, bomb_planted, bomb_exploded, bomb_defused, total_points) VALUES ('%s', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d');",
	g_szPlayerName[id], g_iPlayerStats[id][STATS_GWK], g_iPlayerStats[id][STATS_KILLS_I], g_iPlayerStats[id][STATS_KILLS_D], g_iPlayerStats[id][STATS_KILLS_T], g_iPlayerStats[id][STATS_RDM], g_iPlayerStats[id][STATS_INN], g_iPlayerStats[id][STATS_DET], g_iPlayerStats[id][STATS_TRA], g_iPlayerStats[id][STATS_BOMBP], g_iPlayerStats[id][STATS_BOMBE], g_iPlayerStats[id][STATS_BOMBD], g_iPlayerStats[id][STATS_POINTS]);
	SQL_ThreadQuery(g_pSqlTuple, "IgnoreHandle", temp);
}

stock escape_mysql(string[], len)
{
	replace_all(string, len, "\\", "\\\\");
	replace_all(string, len, "\0", "\\0");
	replace_all(string, len, "\n", "\\n");
	replace_all(string, len, "\r", "\\r");
	replace_all(string, len, "\x1a", "\Z");
	replace_all(string, len, "'", "\'");
	replace_all(string, len, "^"", "\^"");
}

// API
public _set_player_stat(plugin, params)
{
	if(!pluginon)
		return -1;

	if(params != 3)
		return ttt_log_to_file(LOG_ERROR, "Wrong number of params (ttt_set_player_stat)");

	new stat = get_param(2);
	new id = get_param(1);
	new num = get_param(3);

	g_iPlayerStats[id][stat] = num;

	return 1;
}

public _get_player_stat(plugin, params)
{
	if(!pluginon)
		return -1;

	if(params != 2)
		return ttt_log_to_file(LOG_ERROR, "Wrong number of params (ttt_get_player_stat)");

	new stat = get_param(2);
	new id = get_param(1);
	return g_iPlayerStats[id][stat];
}