#include <amxmodx>
#include <engine>
#include <cstrike>
#include <fun>
#include <ttt>

new const WPN_V_MODEL[] = "models/ttt/v_dnascanner.mdl";
new const WPN_P_MODEL[] = "models/ttt/p_dnascanner.mdl";
new const WPN_W_MODEL[] = "models/ttt/w_dnascanner.mdl";

new cvar_price_dna, g_iItem_DNA;
new g_iHasDNAScanner[33], g_iActiveScanner[33];

public plugin_precache()
{
	precache_model(WPN_V_MODEL);
	precache_model(WPN_P_MODEL);
	precache_model(WPN_W_MODEL);
}

public plugin_init()
{
	register_plugin("[TTT] Item: DNA Scanner", TTT_VERSION, TTT_AUTHOR);

	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1");
	register_event("WeapPickup", "Event_WeapPickup", "be", "1=6");

	cvar_price_dna = register_cvar("ttt_price_dna", "2");

	new name[TTT_ITEMNAME];
	formatex(name, charsmax(name), "%L", LANG_PLAYER, "TTT_ITEM_ID5");
	g_iItem_DNA = ttt_buymenu_add(name, get_pcvar_num(cvar_price_dna), DETECTIVE);
}

public plugin_natives()
{
	register_library("ttt");
	register_native("ttt_is_dnas_active", "_is_dnas_active");
}

public client_disconnect(id)
{
	g_iHasDNAScanner[id] = false;
	g_iActiveScanner[id] = false;
}

public ttt_item_selected(id, item, name[], price)
{
	if(g_iItem_DNA == item)
	{
		engclient_cmd(id, "drop", "weapon_c4");
		give_item(id, "weapon_c4");
		set_dna(id, 1, g_iActiveScanner[id]);
		ColorChat(id, NORMAL, "%s %L", TTT_TAG, id, "TTT_ITEM2", name, id, "TTT_ITEM_DNA", name);

		return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}

public ttt_gamemode(gamemode)
{
	if(gamemode == ENDED || gamemode == RESTARTING)
	{
		new num, id;
		static players[32];
		get_players(players, num);
		for(--num; num >= 0; num--)
		{
			id = players[num];
			g_iHasDNAScanner[id] = false;
			g_iActiveScanner[id] = false;
		}
	}
}

public ttt_touchweaponbox(ent, id, model[])
{
	if(!equal(model, WPN_W_MODEL) || g_iHasDNAScanner[id])
		return PLUGIN_CONTINUE;

	set_dna(id, 1, g_iActiveScanner[id]);
	return PLUGIN_HANDLED;
}

public ttt_setmodel(ent, model[])
{
	if(equal(model, WPN_WMODEL[0]))
	{
		static owner;
		owner = entity_get_edict(ent, EV_ENT_owner);
		if(g_iHasDNAScanner[owner])
		{
			entity_set_model(ent, WPN_W_MODEL);
			set_dna(owner, 0, 0);
			return TTT_SUPERCEDE;
		}
	}

	return TTT_IGNORED;
}

public set_dna(id, type1, type2)
{
	g_iHasDNAScanner[id] = type1;
	g_iActiveScanner[id] = type2;
	cs_set_user_plant(id, 0);
	cs_set_user_submodel(id, 0);

	message_begin(MSG_ONE, get_user_msgid("StatusIcon"), _, id);
	write_byte(0);
	write_string("c4");
	message_end();
}

public Event_WeapPickup(id)
{
	if(g_iHasDNAScanner[id])
		set_dna(id, g_iHasDNAScanner[id], g_iActiveScanner[id]);
}

public Event_CurWeapon(id)
{
	if(id == entity_get_int(id, EV_INT_iuser2))
		return;

	g_iActiveScanner[id] = false;
	if(read_data(2) == CSW_C4 && g_iHasDNAScanner[id] && read_data(1))
	{
		entity_set_string(id, EV_SZ_viewmodel, WPN_V_MODEL);
		entity_set_string(id, EV_SZ_weaponmodel, WPN_P_MODEL);
		set_dna(id, g_iHasDNAScanner[id], 1);
	}
}

stock UTIL_PlayWeaponAnimation(const id, const seq)
{
	entity_set_int(id, EV_INT_weaponanim, seq);

	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, .player = id);
	write_byte(seq);
	write_byte(entity_get_int(id, EV_INT_body));
	message_end();
}

public _is_dnas_active(plugin, params)
{
	if(params != 1)
		return ttt_log_to_file(LOG_ERROR, "Wrong number of params (ttt_is_dnas_active)");

	new id = get_param(1);
	return g_iActiveScanner[id];
}